Index: world
===================================================================
--- world	(revision 0)
+++ world	(revision 781)
@@ -0,0 +1 @@
+make buildworld KERNCONF=DIMETRODON -DNO_KERNELCLEAN NOCLEAN=1
Index: test-inst
===================================================================
--- test-inst	(revision 0)
+++ test-inst	(revision 781)
@@ -0,0 +1,3 @@
+make installkernel KERNCONF=DIMETRODON KODIR=/boot/testkernel
+        nextboot -k testkernel	
+
Index: gdb-dump
===================================================================
--- gdb-dump	(revision 0)
+++ gdb-dump	(revision 781)
@@ -0,0 +1,2 @@
+kgdb /usr/obj/usr/dimetrodon/bsd/sys/DIMETRODON/kernel.debug /var/crash/vmcore.2
+
Index: boot-test
===================================================================
--- boot-test	(revision 0)
+++ boot-test	(revision 781)
@@ -0,0 +1 @@
+nextboot -k testkernel
Index: build
===================================================================
--- build	(revision 0)
+++ build	(revision 781)
@@ -0,0 +1 @@
+make buildkernel -j 5 KERNCONF=DIMETRODON -DNO_KERNELCLEAN
Index: install
===================================================================
--- install	(revision 0)
+++ install	(revision 781)
@@ -0,0 +1 @@
+make installkernel KERNCONF=DIMETRODON
Index: sys/conf/files
===================================================================
--- sys/conf/files	(revision 379)
+++ sys/conf/files	(revision 781)
@@ -1578,6 +1578,10 @@
 fs/cd9660/cd9660_vfsops.c	optional cd9660
 fs/cd9660/cd9660_vnops.c	optional cd9660
 fs/cd9660/cd9660_iconv.c	optional cd9660_iconv
+
+# dimetrodon
+kern/sched_heuristics.c		standard
+
 kern/bus_if.m			standard
 kern/clock_if.m			optional genclock
 kern/cpufreq_if.m		standard
Index: sys/kern/kern_thread.c
===================================================================
--- sys/kern/kern_thread.c	(revision 379)
+++ sys/kern/kern_thread.c	(revision 781)
@@ -494,10 +494,14 @@
 		}
 	} 
 	PROC_UNLOCK(p);
+
 	thread_lock(td);
 	/* Save our tick information with both the thread and proc locked */
 	ruxagg(&p->p_rux, td);
 	PROC_SUNLOCK(p);
+
+	KASSERT(td->is_preempted == 0, "Preempted thread is exiting!?!?!");
+
 	td->td_state = TDS_INACTIVE;
 	CTR1(KTR_PROC, "thread_exit: cpu_throw() thread %p", td);
 	sched_throw(td);
Index: sys/kern/kern_switch.c
===================================================================
--- sys/kern/kern_switch.c	(revision 379)
+++ sys/kern/kern_switch.c	(revision 781)
@@ -348,8 +348,9 @@
 	return (-1);
 }
 
+
 static __inline int
-runq_findbit_from(struct runq *rq, u_char pri)
+runq_findbit_from_doagain(struct runq *rq, u_char pri, int doagain)
 {
 	struct rqbits *rqb;
 	rqb_word_t mask;
@@ -376,10 +377,22 @@
 	 * Wrap back around to the beginning of the list just once so we
 	 * scan the whole thing.
 	 */
-	pri = 0;
-	goto again;
+	if(doagain)
+	{
+	    pri = 0;
+	    goto again;
+	}
+
+	return (-1);
 }
 
+static __inline int
+runq_findbit_from(struct runq *rq, u_char pri)
+{
+    return runq_findbit_from_doagain(rq, pri, 1);
+}
+
+
 /*
  * Set the status bit of the queue corresponding to priority level pri,
  * indicating that it is non-empty.
@@ -398,6 +411,19 @@
 }
 
 /*
+ * Move thread to the back of its current runq.  This could be optimized!
+ */
+
+void
+runq_move_to_back(struct runq *rq, struct td_sched *ts)
+{
+	CTR3(KTR_RUNQ, "runq_move_to_back: moving ts %p (%s) to back of rq %p",
+	     ts, ts->ts_thread->td_proc->p_comm, rq);
+	runq_remove(rq, ts);
+	runq_add(rq, ts, (int) NULL);
+}
+
+/*
  * Add the thread to the queue specified by its priority, and set the
  * corresponding status bit.
  */
@@ -407,6 +433,8 @@
 	struct rqhead *rqh;
 	int pri;
 
+	KASSERT(!ts->ts_thread->is_preempted, "adding preempted thread to rq!");
+
 	pri = ts->ts_thread->td_priority / RQ_PPQ;
 	ts->ts_rqindex = pri;
 	runq_setbit(rq, pri);
@@ -415,8 +443,10 @@
 	    ts->ts_thread, ts, ts->ts_thread->td_priority, pri, rqh);
 	if (flags & SRQ_PREEMPTED) {
 		TAILQ_INSERT_HEAD(rqh, ts, ts_procq);
+		CTR0(KTR_RUNQ, "runq_add: at head!");
 	} else {
 		TAILQ_INSERT_TAIL(rqh, ts, ts_procq);
+		CTR0(KTR_RUNQ, "runq_add: at tail!");
 	}
 }
 
@@ -460,6 +490,78 @@
 	return (0);
 }
 
+/*
+ * Return true if there are runnable anointed processes of any priority on the run
+ * queue, false otherwise.  Has no side effects, does not modify the run
+ * queue structure.
+ */
+int
+runq_check_dimetrodon_anointed(struct runq *rq)
+{
+	struct rqhead *rqh;
+	int pri = 0;
+
+	while ((pri = runq_findbit_from_doagain(rq, (u_char) pri, 0)) != -1) {
+		rqh = &rq->rq_queues[pri];
+		struct td_sched *ts;
+		ts = TAILQ_FIRST(rqh);
+
+		while (ts) {
+		    if (ts->ts_thread->td_proc->is_dimetrodon_anointed &&
+			!ts->ts_thread->is_preempted)
+		    {
+			CTR2(KTR_RUNQ, "runq_check_anointed: found proc at pri %d (%s)",
+			     pri, ts->ts_thread->td_proc->p_comm);
+			return (1);
+		    }
+		    
+		    ts = TAILQ_NEXT(ts, ts_procq);
+		}
+		++pri;
+	}
+	
+	CTR0(KTR_RUNQ, "runq_check_anointed: empty");
+
+	return (0);
+}
+
+
+/*
+ * Return true if there are runnable anointed processes of any priority on the run
+ * queue, false otherwise.  Has no side effects, does not modify the run
+ * queue structure.
+ */
+struct td_sched *
+runq_get_dimetrodon_anointed(struct runq *rq)
+{
+	struct rqhead *rqh;
+	int pri = 0;
+
+	while ((pri = runq_findbit_from_doagain(rq, (u_char) pri, 0)) != -1) {
+		rqh = &rq->rq_queues[pri];
+		struct td_sched *ts;
+		ts = TAILQ_FIRST(rqh);
+
+		while (ts) {
+		    if (ts->ts_thread->td_proc->is_dimetrodon_anointed &&
+			!ts->ts_thread->is_preempted)
+		    {
+			CTR2(KTR_RUNQ, "runq_get_anointed: found proc at pri %d (%s)",
+			     pri, ts->ts_thread->td_proc->p_comm);
+			return ts;
+		    }
+		    
+		    ts = TAILQ_NEXT(ts, ts_procq);
+		}
+		++pri;
+	}
+	
+	CTR0(KTR_RUNQ, "runq_check_anointed: empty");
+
+	return NULL;
+}
+
+
 #if defined(SMP) && defined(SCHED_4BSD)
 int runq_fuzz = 1;
 SYSCTL_INT(_kern_sched, OID_AUTO, runq_fuzz, CTLFLAG_RW, &runq_fuzz, 0, "");
@@ -473,9 +575,9 @@
 {
 	struct rqhead *rqh;
 	struct td_sched *ts;
-	int pri;
+	int pri = 0;
 
-	while ((pri = runq_findbit(rq)) != -1) {
+	while ((pri = runq_findbit_from_doagain(rq, (u_char) pri, 0)) != -1) {
 		rqh = &rq->rq_queues[pri];
 #if defined(SMP) && defined(SCHED_4BSD)
 		/* fuzz == 1 is normal.. 0 or less are ignored */
@@ -487,10 +589,10 @@
 			int count = runq_fuzz;
 			int cpu = PCPU_GET(cpuid);
 			struct td_sched *ts2;
-			ts2 = ts = TAILQ_FIRST(rqh);
+			ts2 = TAILQ_FIRST(rqh);
 
 			while (count-- && ts2) {
-				if (ts2->ts_thread->td_lastcpu == cpu) {
+				if (ts2->ts_thread->td_lastcpu == cpu && !ts2->ts_thread->is_preempted) {
 					ts = ts2;
 					break;
 				}
@@ -498,16 +600,44 @@
 			}
 		} else
 #endif
-			ts = TAILQ_FIRST(rqh);
-		KASSERT(ts != NULL, ("runq_choose: no proc on busy queue"));
-		CTR3(KTR_RUNQ,
-		    "runq_choose: pri=%d td_sched=%p rqh=%p", pri, ts, rqh);
-		return (ts);
+		{
+			struct td_sched *ts2;
+			ts2 = TAILQ_FIRST(rqh);
+
+			while (ts2) {
+				if (!ts2->ts_thread->is_preempted) {
+					ts = ts2;
+					break;
+				}
+				ts2 = TAILQ_NEXT(ts2, ts_procq);
+			}
+		}
+
+		/*
+		  If we found a non-preempted thread...
+		 */
+		if(ts)
+		{
+			KASSERT(!ts->ts_thread->is_preempted, "chose a preempted thread!");
+			CTR5(KTR_RUNQ,
+			     "runq_choose: at pri=%d td_sched=%p (pri=%d) rqh=%p, name=%s",
+			     pri, ts, ts->ts_thread->td_priority, rqh, ts->ts_thread->td_proc->p_comm);
+			
+			return (ts);
+		}
+
+		/*
+		  Go to the next priority.
+		*/
+		++pri;
 	}
 	CTR1(KTR_RUNQ, "runq_choose: idleproc pri=%d", pri);
 
 	return (NULL);
 }
+/*
+  Note: THIS IS UNUSED, BUT NEEDS TO BE FIXED IF WE ARE TO USE IT!
+ */
 
 struct td_sched *
 runq_choose_from(struct runq *rq, u_char idx)
Index: sys/kern/kern_idle.c
===================================================================
--- sys/kern/kern_idle.c	(revision 379)
+++ sys/kern/kern_idle.c	(revision 781)
@@ -78,6 +78,7 @@
 		TD_SET_CAN_RUN(td);
 		td->td_flags |= TDF_IDLETD;
 		sched_class(td, PRI_IDLE);
+		td->dimetrodon_idle = 0;
 		sched_prio(td, PRI_MAX_IDLE);
 		thread_unlock(td);
 		PROC_UNLOCK(p);
Index: sys/kern/kern_synch.c
===================================================================
--- sys/kern/kern_synch.c	(revision 379)
+++ sys/kern/kern_synch.c	(revision 781)
@@ -57,6 +57,7 @@
 #include <sys/sysctl.h>
 #include <sys/sysproto.h>
 #include <sys/vmmeter.h>
+#include <sys/sched_heuristics.h>
 #ifdef KTRACE
 #include <sys/uio.h>
 #include <sys/ktrace.h>
@@ -371,7 +372,7 @@
 void
 mi_switch(int flags, struct thread *newtd)
 {
-	uint64_t runtime, new_switchtime;
+        uint64_t runtime, new_switchtime;
 	struct thread *td;
 	struct proc *p;
 
@@ -408,20 +409,50 @@
 	 * Compute the amount of time during which the current
 	 * thread was running, and add that to its total so far.
 	 */
+
+	//set dimetrodon recent ticktimes here--for now, just do 2
+	td->td_recenttick_old = td->td_recenttick_new;
+	td->td_recenttick_new = td->td_currenttick;
+
+	CTR4(KTR_SCHED, "mi_switch ticks: %p(%s) old: %d, new: %d",
+	     td, td->td_proc->p_comm, td->td_recenttick_old,
+	     td->td_recenttick_new);
+
 	new_switchtime = cpu_ticks();
 	runtime = new_switchtime - PCPU_GET(switchtime);
 	td->td_runtime += runtime;
 	td->td_incruntime += runtime;
+
+	/*
+	  For whatever reason, locking the proc causes a deadlock even if we
+	  do ugly reentrant-type locking.
+
+	  We instead use a spinlock for these variables.
+	  Context switching is already expensive...
+	 */
+
+	if(p)
+	{
+		//mtx_lock_spin(&p->tick_lock);
+		p->proc_ticks += td->td_currenttick;
+		p->proc_numquanta++;
+		//mtx_unlock_spin(&p->tick_lock);
+	}
+
 	PCPU_SET(switchtime, new_switchtime);
 	td->td_generation++;	/* bump preempt-detect counter */
 	PCPU_INC(cnt.v_swtch);
+
 	PCPU_SET(switchticks, ticks);
 	CTR4(KTR_PROC, "mi_switch: old thread %ld (kse %p, pid %ld, %s)",
 	    td->td_tid, td->td_sched, p->p_pid, p->p_comm);
 #if (KTR_COMPILE & KTR_SCHED) != 0
-	if (TD_IS_IDLETHREAD(td))
-		CTR3(KTR_SCHED, "mi_switch: %p(%s) prio %d idle",
+	if (TD_IS_IDLETHREAD(td) && !td->dimetrodon_idle)
+		CTR3(KTR_SCHED, "mi_switch from idle: %p(%s) prio %d idle",
 		    td, td->td_proc->p_comm, td->td_priority);
+	else if (TD_IS_IDLETHREAD(td) && td->dimetrodon_idle)
+		CTR3(KTR_SCHED, "mi_switch from dimetrodon idle: %p(%s) prio %d idle",
+		    td, td->td_proc->p_comm, td->td_priority);
 	else if (newtd != NULL)
 		CTR5(KTR_SCHED,
 		    "mi_switch: %p(%s) prio %d preempted by %p(%s)",
@@ -445,8 +476,8 @@
 	CTR3(KTR_SCHED, "mi_switch: running %p(%s) prio %d",
 	    td, td->td_proc->p_comm, td->td_priority);
 
-	CTR4(KTR_PROC, "mi_switch: new thread %ld (kse %p, pid %ld, %s)",
-	    td->td_tid, td->td_sched, p->p_pid, p->p_comm);
+	CTR5(KTR_PROC, "mi_switch: new thread %ld (kse %p, pid %ld, %s, dimetrodon: %d)",
+	     td->td_tid, td->td_sched, p->p_pid, p->p_comm, td->dimetrodon_idle);
 
 	/* 
 	 * If the last thread was exiting, finish cleaning it up.
@@ -484,6 +515,8 @@
 	case TDS_CAN_RUN:
 		break;
 	default:
+		if(td->is_preempted)
+			break;
 		printf("state is 0x%x", td->td_state);
 		panic("setrunnable(2)");
 	}
Index: sys/kern/init_main.c
===================================================================
--- sys/kern/init_main.c	(revision 379)
+++ sys/kern/init_main.c	(revision 781)
@@ -393,6 +393,8 @@
 	 * Add scheduler specific parts to proc, thread as needed.
 	 */
 	schedinit();	/* scheduler gets its house in order */
+	mtx_init(&p->tick_lock, "proc tick lock", NULL, MTX_SPIN);
+
 	/*
 	 * Initialize sleep queue hash table
 	 */
Index: sys/kern/kern_clock.c
===================================================================
--- sys/kern/kern_clock.c	(revision 379)
+++ sys/kern/kern_clock.c	(revision 781)
@@ -264,6 +264,13 @@
 	struct thread *td = curthread;
 	struct proc *p = td->td_proc;
 	int flags;
+	
+	CTR5(KTR_SCHED,
+	     "hardclock_cpu: td %p(%s) %d ticks, needresched(%d) dimetrodon:%d",
+	     td, td->td_proc->p_comm, ticks-PCPU_GET(switchticks),
+	     td->td_flags & TDF_NEEDRESCHED, td->dimetrodon_idle);
+	
+	td->td_currenttick = ticks-PCPU_GET(switchticks);
 
 	/*
 	 * Run current process's virtual and profile time, as needed.
@@ -527,8 +534,9 @@
 	rss = pgtok(vmspace_resident_count(vm));
 	if (ru->ru_maxrss < rss)
 		ru->ru_maxrss = rss;
-	CTR4(KTR_SCHED, "statclock: %p(%s) prio %d stathz %d",
-	    td, td->td_proc->p_comm, td->td_priority, (stathz)?stathz:hz);
+//	CTR4(KTR_SCHED, "statclock: %p(%s) prio %d stathz %d",
+//	    td, td->td_proc->p_comm, td->td_priority, (stathz)?stathz:hz);
+
 	thread_lock_flags(td, MTX_QUIET);
 	sched_clock(td);
 	thread_unlock(td);
Index: sys/kern/kern_proc.c
===================================================================
--- sys/kern/kern_proc.c	(revision 379)
+++ sys/kern/kern_proc.c	(revision 781)
@@ -283,7 +283,7 @@
 pfind(pid)
 	register pid_t pid;
 {
-	register struct proc *p;
+	register struct proc *p = NULL;
 
 	sx_slock(&allproc_lock);
 	LIST_FOREACH(p, PIDHASH(pid), p_hash)
Index: sys/kern/sched_4bsd.c
===================================================================
--- sys/kern/sched_4bsd.c	(revision 379)
+++ sys/kern/sched_4bsd.c	(revision 781)
@@ -1,5 +1,4 @@
-/*-
- * Copyright (c) 1982, 1986, 1990, 1991, 1993
+/*- * Copyright (c) 1982, 1986, 1990, 1991, 1993
  *	The Regents of the University of California.  All rights reserved.
  * (c) UNIX System Laboratories, Inc.
  * All or some portions of this file are derived from material licensed
@@ -54,6 +53,7 @@
 #include <sys/sx.h>
 #include <sys/turnstile.h>
 #include <sys/umtx.h>
+#include <sys/sched_heuristics.h>
 #include <machine/pcb.h>
 #include <machine/smp.h>
 
@@ -259,10 +259,19 @@
 static void
 maybe_resched(struct thread *td)
 {
+        if(TD_IS_IDLETHREAD(curthread) && curthread->dimetrodon_idle)
+            return;
 
 	THREAD_LOCK_ASSERT(td, MA_OWNED);
 	if (td->td_priority < curthread->td_priority)
+	{
+		CTR5(KTR_SCHED,
+		     "maybe_resched: td %p(%s) %d ticks, %d quantum, needresched(%d)",
+		     td, td->td_proc->p_comm, ticks-PCPU_GET(switchticks), sched_quantum,
+		     td->td_flags & TDF_NEEDRESCHED);
+
 		curthread->td_flags |= TDF_NEEDRESCHED;
+ 	}
 }
 
 /*
@@ -459,7 +468,6 @@
 static void
 schedcpu_thread(void)
 {
-
 	for (;;) {
 		schedcpu();
 		pause("-", hz);
@@ -524,7 +532,8 @@
 		return;
 
 	/* XXX the whole needresched thing is broken, but not silly. */
-	maybe_resched(td);
+	if(!(TD_IS_IDLETHREAD(curthread) && curthread->dimetrodon_idle))
+		maybe_resched(td);
 
 	sched_prio(td, td->td_user_pri);
 }
@@ -574,6 +583,16 @@
 #endif
 }
 
+static int sched_runnable_dimetrodon_anointed(void)
+{
+#ifdef SMP
+	return runq_check_dimetrodon_anointed(&runq) + 
+		runq_check_dimetrodon_anointed(&runq_pcpu[PCPU_GET(cpuid)]);
+#else
+	return runq_check_dimetrodon_anointed(&runq);
+#endif
+}
+
 int
 sched_rr_interval(void)
 {
@@ -599,50 +618,105 @@
 void
 sched_clock(struct thread *td)
 {
-	struct td_sched *ts;
+	struct td_sched *ts, *actualts;
+	struct thread *actualtd;
+	int isidlethread;
+	int tickssofar;
 
+	isidlethread = TD_IS_IDLETHREAD(td);
+
 	THREAD_LOCK_ASSERT(td, MA_OWNED);
 	ts = td->td_sched;
 
-	ts->ts_cpticks++;
-	td->td_estcpu = ESTCPULIM(td->td_estcpu + 1);
-	if ((td->td_estcpu % INVERSE_ESTCPU_WEIGHT) == 0) {
-		resetpriority(td);
-		resetpriority_thread(td);
+	if(!td->dimetrodon_idle)
+	{
+		actualts = ts;
+		actualtd = curthread;
 	}
+	else
+	{
+		actualtd = td->dimetrodon_wouldrun;
+		actualts = actualtd->td_sched;
+	}
+		
+	actualts->ts_cpticks++;
+	actualtd->td_estcpu = ESTCPULIM(actualtd->td_estcpu + 1);
+	
+	if ((actualtd->td_estcpu % INVERSE_ESTCPU_WEIGHT) == 0) {
+		resetpriority(actualtd);
+		resetpriority_thread(actualtd);
+	}
 
+
 	/*
 	 * Force a context switch if the current thread has used up a full
 	 * quantum (default quantum is 100ms).
 	 */
-	if (!TD_IS_IDLETHREAD(td) &&
-	    ticks - PCPU_GET(switchticks) >= sched_quantum)
+
+	//dimetrodon: don't context switch in idle thread, like normal, but
+	//if we're idling in dimetrodon, we actually do want to switch at quantum
+	//depletion
+
+	tickssofar = ticks-PCPU_GET(switchticks);
+
+	if ((td->dimetrodon_idle <= tickssofar && td->dimetrodon_idle > 0 && isidlethread)
+	    ||
+	    ((!(isidlethread || td->dimetrodon_idle))
+	     &&
+	     tickssofar >= sched_quantum))
+	{
+		if(td->dimetrodon_idle)
+			CTR5(KTR_SCHED,
+			     "sched_clock dimetrodon: td %p(%s) %d ticks, %d dimetrodon, needresched(%d)",
+			     td, td->td_proc->p_comm, ticks-PCPU_GET(switchticks), td->dimetrodon_idle,
+			     td->td_flags & TDF_NEEDRESCHED);
+		else
+			CTR5(KTR_SCHED,
+			     "sched_clock: td %p(%s) %d ticks, %d quantum, needresched(%d)",
+			     td, td->td_proc->p_comm, ticks-PCPU_GET(switchticks), sched_quantum,
+			     td->td_flags & TDF_NEEDRESCHED);
+	
+		if(td->dimetrodon_idle)
+			increment_idle_count();
+		else
+			increment_real_count_cond();
+
+		td->td_currenttick = tickssofar;
+
 		td->td_flags |= TDF_NEEDRESCHED;
+	}
 }
 
+
 /*
  * Charge child's scheduling CPU usage to parent.
  */
 void
 sched_exit(struct proc *p, struct thread *td)
 {
-
 	CTR3(KTR_SCHED, "sched_exit: %p(%s) prio %d",
 	    td, td->td_proc->p_comm, td->td_priority);
 	PROC_SLOCK_ASSERT(p, MA_OWNED);
+
 	sched_exit_thread(FIRST_THREAD_IN_PROC(p), td);
 }
 
 void
 sched_exit_thread(struct thread *td, struct thread *child)
 {
-
 	CTR3(KTR_SCHED, "sched_exit_thread: %p(%s) prio %d",
 	    child, child->td_proc->p_comm, child->td_priority);
+
 	thread_lock(td);
 	td->td_estcpu = ESTCPULIM(td->td_estcpu + child->td_estcpu);
 	thread_unlock(td);
+
 	mtx_lock_spin(&sched_lock);
+	if(child->is_preempted)
+	{
+	    child->preempting_thread->dimetrodon_wouldrun = 0;
+	    child->is_preempted = 0;
+	}
 	if ((child->td_proc->p_flag & P_NOLOAD) == 0)
 		sched_load_rem();
 	mtx_unlock_spin(&sched_lock);
@@ -651,6 +725,8 @@
 void
 sched_fork(struct thread *td, struct thread *childtd)
 {
+	//blessed are the children of the anointed
+	childtd->td_proc->is_dimetrodon_anointed = td->td_proc->is_dimetrodon_anointed;
 	sched_fork_thread(td, childtd);
 }
 
@@ -660,7 +736,18 @@
 	childtd->td_estcpu = td->td_estcpu;
 	childtd->td_lock = &sched_lock;
 	childtd->td_cpuset = cpuset_ref(td->td_cpuset);
+	
+	childtd->td_recenttick_new = td->td_recenttick_new;
+	childtd->td_recenttick_old = td->td_recenttick_old;
+	childtd->td_currenttick = 0;
+
 	sched_newthread(childtd);
+	childtd->is_preempted = 0;
+	childtd->preempting_thread = NULL;
+	if(childtd->td_proc && td->td_proc)
+	{
+		childtd->td_proc->dimetrodon_always_preempt = td->td_proc->dimetrodon_always_preempt;
+	}
 	childtd->td_sched->ts_flags |= (td->td_sched->ts_flags & TSF_AFFINITY);
 }
 
@@ -693,6 +780,9 @@
 static void
 sched_priority(struct thread *td, u_char prio)
 {
+	if(td->dimetrodon_idle)
+		return;
+
 	CTR6(KTR_SCHED, "sched_prio: %p(%s) prio %d newprio %d by %p(%s)",
 	    td, td->td_proc->p_comm, td->td_priority, prio, curthread,
 	    curthread->td_proc->p_comm);
@@ -748,6 +838,9 @@
 void
 sched_prio(struct thread *td, u_char prio)
 {
+	if(td->dimetrodon_idle)
+		return;
+
 	u_char oldprio;
 
 	/* First, update the base priority. */
@@ -824,7 +917,7 @@
 void
 sched_switch(struct thread *td, struct thread *newtd, int flags)
 {
-	struct td_sched *ts;
+        struct td_sched *ts;
 	struct proc *p;
 
 	ts = td->td_sched;
@@ -859,9 +952,12 @@
 	 * threads on the run queue, however.
 	 */
 	if (td->td_flags & TDF_IDLETD) {
-		TD_SET_CAN_RUN(td);
+		if(!td->dimetrodon_idle)
+			TD_SET_CAN_RUN(td);
+
 #ifdef SMP
-		idle_cpus_mask &= ~PCPU_GET(cpumask);
+		if (!td->dimetrodon_idle)
+			idle_cpus_mask &= ~PCPU_GET(cpumask);
 #endif
 	} else {
 		if (TD_IS_RUNNING(td)) {
@@ -871,6 +967,8 @@
 			    SRQ_OURSELF|SRQ_YIELDING);
 		}
 	}
+
+
 	if (newtd) {
 		/*
 		 * The thread we are about to run needs to be counted
@@ -931,7 +1029,7 @@
 	}
 
 #ifdef SMP
-	if (td->td_flags & TDF_IDLETD)
+	if (td->td_flags & TDF_IDLETD && !td->dimetrodon_idle)
 		idle_cpus_mask |= PCPU_GET(cpumask);
 #endif
 	sched_lock.mtx_lock = (uintptr_t)td;
@@ -1132,7 +1230,6 @@
 		thread_lock_set(td, &sched_lock);
 	}
 	TD_SET_RUNQ(td);
-
 	if (td->td_pinned != 0) {
 		cpu = td->td_lastcpu;
 		ts->ts_runq = &runq_pcpu[cpu];
@@ -1272,8 +1369,23 @@
 sched_choose(void)
 {
 	struct td_sched *ts;
+	struct thread *td, *wouldrun;
 	struct runq *rq;
 
+	if(curthread->dimetrodon_wouldrun)
+	{
+		curthread->dimetrodon_wouldrun->preempting_thread = NULL;
+		curthread->dimetrodon_wouldrun->is_preempted = 0;
+
+		KASSERT((curtd->dimetrodon_wouldrun->
+			 td_sched->ts_runq != NULL),
+			("preempted thread has null runq!"));
+		runq_move_to_back(curthread->dimetrodon_wouldrun->td_sched->ts_runq,
+				  curthread->dimetrodon_wouldrun->td_sched);
+	}
+
+	curthread->dimetrodon_idle = 0;
+
 	mtx_assert(&sched_lock,  MA_OWNED);
 #ifdef SMP
 	struct td_sched *kecpu;
@@ -1282,15 +1394,39 @@
 	ts = runq_choose(&runq);
 	kecpu = runq_choose(&runq_pcpu[PCPU_GET(cpuid)]);
 
+	if(ts != NULL && kecpu != NULL && ts->ts_thread && kecpu->ts_thread && ts->ts_thread->td_proc && kecpu->ts_thread->td_proc)
+	{
+	    CTR4(KTR_RUNQ, "got td_scheds for %s(pri:%d) and %s(pri:%d)", 
+		 kecpu->ts_thread->td_proc->p_comm,
+		 kecpu->ts_thread->td_priority,
+		 ts->ts_thread->td_proc->p_comm,
+		 ts->ts_thread->td_priority);
+	}
+	else if(ts == NULL)
+	    CTR0(KTR_RUNQ, "ts == NULL runq_choose");
+
+
 	if (ts == NULL ||
 	    (kecpu != NULL &&
 	     kecpu->ts_thread->td_priority < ts->ts_thread->td_priority)) {
-		CTR2(KTR_RUNQ, "choosing td_sched %p from pcpu runq %d", kecpu,
+/*
+	    if(kecpu->ts_thread && kecpu->ts_thread->td_proc)
+		CTR3(KTR_RUNQ, "sched_choose: choosing td_sched %p(%s) from pcpu runq %d", kecpu,
+		     kecpu->ts_thread->td_proc->p_comm, PCPU_GET(cpuid));
+	    else
+		CTR2(KTR_RUNQ, "sched_choose: choosing td_sched %p(%s) from pcpu runq %d", kecpu,
 		     PCPU_GET(cpuid));
-		ts = kecpu;
-		rq = &runq_pcpu[PCPU_GET(cpuid)];
+*/
+	    ts = kecpu;
+	    rq = &runq_pcpu[PCPU_GET(cpuid)];
 	} else {
-		CTR1(KTR_RUNQ, "choosing td_sched %p from main runq", ts);
+/*
+	    if(ts && ts->ts_thread && ts->ts_thread->td_proc)
+		CTR2(KTR_RUNQ, "sched_choose: choosing td_sched %p(%s) from main runq", ts,
+		     ts->ts_thread->td_proc->p_comm);
+	    else
+		CTR1(KTR_RUNQ, "sched_choose: choosing td_sched %p(%s) from main runq", ts);
+*/
 	}
 
 #else
@@ -1299,18 +1435,104 @@
 #endif
 
 	if (ts) {
+		wouldrun = ts->ts_thread;
+
+		//DIMETRODON HACK
+		if(do_schedule_now(wouldrun) == 0)
+		{
+
+			/*
+			rq = &runq;
+			anointed = runq_get_dimetrodon_anointed(&runq);
 #ifdef SMP
+			kecpu = runq_get_dimetrodon_anointed(&runq_pcpu[PCPU_GET(cpuid)]);
+
+			if (anointed == NULL ||
+			    (kecpu != NULL &&
+			     kecpu->ts_thread->td_priority < ts->ts_thread->td_priority)) {
+				anointed = kecpu;
+				rq = &runq_pcpu[PCPU_GET(cpuid)];
+			}
+#endif
+
+			if(anointed != NULL)
+			{
+#ifdef SMP
+				if (ts == kecpu)
+					runq_length[PCPU_GET(cpuid)]--;
+#endif
+				runq_remove(rq, ts);
+				ts->ts_thread->td_flags |= TDF_DIDRUN;
+
+				CTR5(KTR_SCHED, "sched_choose: returning anointed %p(%s) prio %d by %p(%s)",
+				     ts->ts_thread, ts->ts_thread->td_proc->p_comm, ts->ts_thread->td_priority, curthread,
+				     curthread->td_proc->p_comm);			
+
+				return ts->ts_thread;
+			}
+			 
+			*/
+#ifdef SMP
+		        if (ts == kecpu)
+			        runq_length[PCPU_GET(cpuid)]--;
+#endif
+
+			td = PCPU_GET(idlethread);
+			//this is probably overkill, but let's just copy
+			//the real version below
+			td->td_flags |= TDF_DIDRUN;
+
+			wouldrun->is_preempted = 1;
+			wouldrun->preempting_thread = td;
+			td->dimetrodon_wouldrun = wouldrun;
+
+			//run for a fixed amount
+			if(dimetrodon_chosen_idletime_kind == IDLETIME_SET_TICKS)
+			{
+			        td->dimetrodon_idle = dimetrodon_idle_ticks;
+			}
+			//run for the amount of time that the thread would have run.
+			else
+			{
+			        td->dimetrodon_idle = MIN(
+				  MAX_IDLETIME,
+				  MAX(((wouldrun->td_recenttick_old + 
+					wouldrun->td_recenttick_new)/2),
+				      dimetrodon_min_idle_ticks));
+			}
+
+			CTR6(KTR_SCHED, "sched_choose: returning dimetrodon %p(%s) dimetrodon %d by %p(%s) instead of %s",
+			     td, td->td_proc->p_comm, td->dimetrodon_idle, curthread,
+			     curthread->td_proc->p_comm, wouldrun->td_proc->p_comm);
+
+			return td;
+		}
+
+#ifdef SMP
 		if (ts == kecpu)
 			runq_length[PCPU_GET(cpuid)]--;
 #endif
 		runq_remove(rq, ts);
 		ts->ts_thread->td_flags |= TDF_DIDRUN;
 
+		td = ts->ts_thread;
+
+		KASSERT(!td->is_preempted, "got a preempted thread!?!");
+
+		CTR5(KTR_SCHED, "sched_choose: returning other %p(%s) prio %d by %p(%s)",
+		     td, td->td_proc->p_comm, td->td_priority, curthread,
+		     curthread->td_proc->p_comm);
+
 		KASSERT(ts->ts_thread->td_flags & TDF_INMEM,
 		    ("sched_choose: thread swapped out"));
 		return (ts->ts_thread);
 	}
-	return (PCPU_GET(idlethread));
+
+	//return idle thread, but make sure we don't do the dimetrodon idle
+	td = PCPU_GET(idlethread);
+	td->dimetrodon_wouldrun = NULL;
+	td->dimetrodon_idle = 0;
+	return td;
 }
 
 void
@@ -1409,6 +1631,26 @@
 void
 sched_tick(void)
 {
+	/*
+	 * Stathz is 133 hz by default, which means it will get checked every
+	 * 7.5 milliseconds, or 7.5 ticks.  In order to allow finer-grained idle
+	 * cycle lengths, we want better resolution than this, so check every
+	 * tick if we need to preempt Dimetrodon threads.
+	 */
+
+	if (curthread->dimetrodon_idle
+	    && TD_IS_IDLETHREAD(curthread)
+	    && (curthread->dimetrodon_idle <= ticks-PCPU_GET(switchticks)))
+	{
+		CTR5(KTR_SCHED,
+		     "sched_tick dimetrodon: td %p(%s) %d ticks, %d dimetrodon, needresched(%d)",
+		     curthread, curthread->td_proc->p_comm, ticks-PCPU_GET(switchticks), curthread->dimetrodon_idle,
+		     curthread->td_flags & TDF_NEEDRESCHED);
+
+		increment_idle_count();
+
+		curthread->td_flags |= TDF_NEEDRESCHED;
+	}
 }
 
 /*
@@ -1419,15 +1661,52 @@
 {
 	struct proc *p;
 	struct thread *td;
+	int hadanointed = 0;
 
 	td = curthread;
+	//initialize this to false, just in case!
+	td->dimetrodon_idle = 0;
+
 	p = td->td_proc;
 	for (;;) {
 		mtx_assert(&Giant, MA_NOTOWNED);
 
-		while (sched_runnable() == 0)
+		/*
+		  dimetrodon
+
+		  break out of idle loop in two conditions:
+
+		  if we're not the dimetrodon idle process (we're just idling by choice,
+		  and not because we were idled by dimetrodon in sched_choose, then
+		  break once another thread becomes runnable
+
+		  if we are the dimetrodon idle process, run until we get rescheduled
+		*/
+
+		while (((td->dimetrodon_idle == 0) && (sched_runnable() == 0))
+		       ||
+		       ((td->dimetrodon_idle != 0) &&
+			(!(td->td_flags & TDF_NEEDRESCHED)) &&
+			((hadanointed = sched_runnable_dimetrodon_anointed()) == 0)))
+		{
+			CTR2(KTR_SCHED,
+			     "idletd: dimetrodon %d, ticks %d",
+			     curthread->dimetrodon_idle, ticks-PCPU_GET(switchticks));
 			cpu_idle();
+		}
 
+		if(td->dimetrodon_idle != 0)
+		{
+		    if(td->td_flags & TDF_NEEDRESCHED)
+		    {
+			CTR0(KTR_RUNQ, "idle: dime neededresched");
+		    }
+		    if(hadanointed == 1)
+		    {
+			CTR0(KTR_RUNQ, "idle: hadanointed");
+		    }
+		}
+
 		mtx_lock_spin(&sched_lock);
 		mi_switch(SW_VOL, NULL);
 		mtx_unlock_spin(&sched_lock);
@@ -1441,7 +1720,7 @@
 sched_throw(struct thread *td)
 {
 	/*
-	 * Correct spinlock nesting.  The idle thread context that we are
+	 * Correct spinlock nesting.  the idle thread context that we are
 	 * borrowing was created so that it would start out with a single
 	 * spin lock (sched_lock) held in fork_trampoline().  Since we've
 	 * explicitly acquired locks in this function, the nesting count
@@ -1482,6 +1761,9 @@
 	struct td_sched *ts;
 	int cpu;
 
+        if(curthread->dimetrodon_idle && td == curthread->dimetrodon_wouldrun)
+	        return;
+
 	THREAD_LOCK_ASSERT(td, MA_OWNED);	
 
 	/*
Index: sys/kern/kern_cpu.c
===================================================================
--- sys/kern/kern_cpu.c	(revision 379)
+++ sys/kern/kern_cpu.c	(revision 781)
@@ -131,12 +131,16 @@
 DRIVER_MODULE(cpufreq, cpu, cpufreq_driver, cpufreq_dc, 0, 0);
 
 static int		cf_lowest_freq;
+static int		cf_highest_freq;
 static int		cf_verbose;
 TUNABLE_INT("debug.cpufreq.lowest", &cf_lowest_freq);
+TUNABLE_INT("debug.cpufreq.highest", &cf_highest_freq);
 TUNABLE_INT("debug.cpufreq.verbose", &cf_verbose);
 SYSCTL_NODE(_debug, OID_AUTO, cpufreq, CTLFLAG_RD, NULL, "cpufreq debugging");
 SYSCTL_INT(_debug_cpufreq, OID_AUTO, lowest, CTLFLAG_RW, &cf_lowest_freq, 1,
     "Don't provide levels below this frequency.");
+SYSCTL_INT(_debug_cpufreq, OID_AUTO, highest, CTLFLAG_RW, &cf_highest_freq, 1,
+    "Don't provide levels above this frequency.");
 SYSCTL_INT(_debug_cpufreq, OID_AUTO, verbose, CTLFLAG_RW, &cf_verbose, 1,
     "Print verbose debugging messages");
 
@@ -302,6 +306,14 @@
 		goto out;
 	}
 
+	/* Reject levels that are above our specified threshold. */
+	if (cf_highest_freq > 0 && level->total_set.freq > cf_highest_freq) {
+		CF_DEBUG("rejecting freq %d, greater than %d limit\n",
+		    level->total_set.freq, cf_highest_freq);
+		error = EINVAL;
+		goto out;
+	}
+
 	/* If already at this level, just return. */
 	if (CPUFREQ_CMP(sc->curr_level.total_set.freq, level->total_set.freq)) {
 		CF_DEBUG("skipping freq %d, same as current level %d\n",
@@ -624,8 +636,13 @@
 			continue;
 		}
 
-		/* Skip levels that have a frequency that is too low. */
-		if (lev->total_set.freq < cf_lowest_freq) {
+		/*
+		 * Skip levels that have a frequency that is too low or too
+		 * high.
+		 */
+		if (lev->total_set.freq < cf_lowest_freq ||
+		    (cf_highest_freq > 0 &&
+		     lev->total_set.freq > cf_highest_freq)) {
 			sc->all_count--;
 			continue;
 		}
Index: sys/kern/subr_turnstile.c
===================================================================
--- sys/kern/subr_turnstile.c	(revision 379)
+++ sys/kern/subr_turnstile.c	(revision 781)
@@ -240,7 +240,7 @@
 		 * If lock holder is actually running or on the run queue
 		 * then we are done.
 		 */
-		if (TD_IS_RUNNING(td) || TD_ON_RUNQ(td)) {
+		if (TD_IS_RUNNING(td) || TD_ON_RUNQ(td) || td->is_preempted) {
 			MPASS(td->td_blocked == NULL);
 			thread_unlock(td);
 			return;
Index: sys/kern/kern_fork.c
===================================================================
--- sys/kern/kern_fork.c	(revision 379)
+++ sys/kern/kern_fork.c	(revision 781)
@@ -429,6 +429,8 @@
 	LIST_INSERT_HEAD(&allproc, p2, p_list);
 	LIST_INSERT_HEAD(PIDHASH(p2->p_pid), p2, p_hash);
 
+	mtx_init(&p2->tick_lock, "proc tick lock", NULL, MTX_SPIN);
+
 	PROC_LOCK(p2);
 	PROC_LOCK(p1);
 
